%define upstream_version 2.0.0
%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%define upstream_name tripleo-heat-templates
%define old_version_name mitaka

Name:          openstack-%{upstream_name}-compat
Summary:       Heat templates for TripleO old version support
Version:       2.0.0
Release:       62%{?dist}
License:       ASL 2.0
Group:         System Environment/Base
URL:           https://wiki.openstack.org/wiki/TripleO
Source0:       http://tarballs.openstack.org/%{upstream_name}/%{upstream_name}-%{version}.tar.gz

#patches_base=+2
Patch0001: 0001-Remove-password-default-for-AodhPassword.patch
Patch0002: 0002-Don-t-restart-Pacemaker-managed-services-from-Puppet.patch
Patch0003: 0003-Add-quotes-around-the-cinder_iscsi_ip_address-value.patch
Patch0004: 0004-compute-restart-OVS-agent-on-neutron.conf-changes.patch
Patch0005: 0005-change-the-default-satellite-tools-rpm-repo.patch
Patch0006: 0006-Set-UpdateIdentifier-for-upgrade-converge-to-prevent.patch
Patch0007: 0007-PLUMgrid-Neutron-integration.patch
Patch0008: 0008-Enable-galera-replication-for-Mariadb-10.1.patch
Patch0009: 0009-Restart-haproxy-after-configuring-SSL-certs.patch
Patch0010: 0010-Add-removal-of-the-etc-resolv.conf.save-file-for-bug.patch
Patch0011: 0011-Filter-for-local-nodes-in-check_resource-function.patch
Patch0012: 0012-Disable-Nova-v3-API.patch
Patch0013: 0013-Remove-hack-the-pulls-latest-docker.patch
Patch0014: 0014-Add-EndpointMap-as-output.patch
Patch0015: 0015-Keep-setting-backend_host-to-hostgroup-for-rbd-backe.patch
Patch0016: 0016-Centos-gives-dev-pts-ptmx-the-wrong-perms.patch
Patch0017: 0017-Nova-needs-the-proper-volumes-to-use-Cinder.patch
Patch0018: 0018-Deploy-Gnocchi-as-a-Ceilometer-metrics-storage-backe.patch
Patch0019: 0019-The-Sahara-SSL-endpoint-was-announced-on-the-wrong-p.patch
Patch0020: 0020-Fix-the-Sahara-public-endpoint-and-make-it-point-to-.patch
Patch0021: 0021-Fix-controller-no-external.yaml-in-bonded-configs.patch
Patch0022: 0022-Disable-VIPs-before-stopping-cluster-during-version-.patch
Patch0023: 0023-Fix-the-ManagementNetValueSpecs-param-type.patch
Patch0024: 0024-Updates-ControlPlaneSubnetCidr-to-be-a-string.patch
Patch0025: 0025-Use-a-different-ceph-key-for-admin-client-user.patch
Patch0026: 0026-Fix-Neutron-enable_-_agent-Hiera-parameters.patch
Patch0027: 0027-Make-sure-openstack-services-are-dependent-on-openst.patch
Patch0028: 0028-Update-management_from_pool-template-version-to-2015.patch
Patch0029: 0029-Tighten-the-access-rules-for-galera.patch
Patch0030: 0030-Don-t-have-separate-protocols-ports-for-Keystone-v3.patch
Patch0031: 0031-Fix-ceph-keyring-setting-for-gnocchi.patch
Patch0032: 0032-Enable-bulk-delete-in-swift-for-gnocchi.patch
Patch0033: 0033-Update-.sh-references-from-openstack-keystone-to-ope.patch
Patch0034: 0034-Aodh-upgrade-heat-template-and-manifests-to-replace-.patch
Patch0035: 0035-Add-coordination-url-to-gnocchi.patch
Patch0036: 0036-Fix-distinguishing-between-stack-create-and-stack-up.patch
Patch0037: 0037-Add-redis-constraint-to-aodh-upgrade-manifest.patch
Patch0038: 0038-OSP-only-use-puppet-pacemaker.yaml-values-in-resourc.patch
Patch0039: 0039-OSP-only-Retain-existing-ComputeHostnameFormat-when-.patch
Patch0040: 0040-Include-bulk-in-swift-proxy-pipeline.patch
Patch0041: 0041-Ensure-the-Heat-Domain-parameters-before-starting-he.patch
Patch0042: 0042-Keystone-liberty-mitaka-upgrade-step.patch
Patch0043: 0043-Stop-no-opping-PackageUpdate-on-upgrade.patch
Patch0044: 0044-Add-require-all-false-to-aodh-upgrade-constraint.patch
Patch0045: 0045-Allow-pacemaker-ports-in-firewall.patch
Patch0046: 0046-Allow-sahara-ports-in-firewall.patch
Patch0047: 0047-L-M-upgrades-keystone-change-of-path-of-the-paste_de.patch
Patch0048: 0048-Disable-stonith-temporarily-during-upgrades.patch
Patch0049: 0049-Fix-ceilometer-auth-url.patch
Patch0050: 0050-Increase-cluster-sync-timeout-for-M-N-major-upgrades.patch
Patch0051: 0051-Install-packages-for-new-components-on-upgrade.patch
Patch0052: 0052-Dump-and-restore-galera-db-during-major-upgrades.patch
Patch0053: 0053-set-aodh-auth_url-explicitly.patch
Patch0054: 0054-Allow-neutron_options-customization-for-dashboard.patch
Patch0055: 0055-Reload-haproxy-after-injecting-certs-w-o-pcmk-too.patch
Patch0056: 0056-Create-openstack-core-resource-regardless-of-enable_.patch
Patch0057: 0057-openstack-core-resource-does-not-have-interleave-tru.patch
Patch0058: 0058-Remove-two-races-during-the-L-M-Keystone-under-httpd.patch
Patch0059: 0059-Repurpose-KeystoneWorkers-add-keystone-wsgi-apache-t.patch
Patch0060: 0060-Merge-pacemaker_master-sync_db-conditionals.patch
Patch0061: 0061-Add-base-constraint-so-gnocchi-metricd-is-tied-to-co.patch
Patch0062: 0062-Install-python-cradox-explicitly-during-upgrades.patch
Patch0063: 0063-Use-create-legacy-resource-types-during-gnocchi-upgr.patch
Patch0064: 0064-Change-default-documentation-URL.patch
Patch0065: 0065-Fix-ceilometer-auth-url-for-compute.patch
Patch0066: 0066-downstream-only-UpgradeInitCommand-for-OSP.patch
Patch0067: 0067-Set-secure_proxy_ssl_header-HTTP_X_FORWARDED_PROTO-f.patch
Patch0068: 0068-Configure-Nova-cache-options-correctly-Mitaka-only.patch
Patch0069: 0069-Fix-network-isolation.yaml-to-stop-clobbering-Manage.patch
Patch0070: 0070-We-don-t-need-to-set-a-default-for-the-CephX-keys-an.patch
Patch0071: 0071-Restore-CephAdminKey-and-CephMonKey-default.patch
Patch0072: 0072-Revert-Restore-CephAdminKey-and-CephMonKey-default.patch
Patch0073: 0073-Revert-We-don-t-need-to-set-a-default-for-the-CephX-.patch
Patch0074: 0074-Remove-the-ControllerCount-constraint.patch
Patch0075: 0075-Increase-RabbitMQ-maximum-file-descriptors.patch
Patch0076: 0076-Properly-direct-MTU-parameters-and-allow-service-def.patch
Patch0077: 0077-Add-parameter-for-enabling-purging-configuration-fil.patch
Patch0078: 0078-Don-t-trigger-mariadb-upgrade-dump-restore-when-not-.patch
Patch0079: 0079-Populate-vnc_api_lib.ini-on-compute-nodes-with-OpenC.patch
Patch0080: 0080-Update-OpenContrail-loadbalancer-plugin-value.patch
Patch0081: 0081-Fix-api_extensions_path-in-neutron-opencontrail-envi.patch
Patch0082: 0082-Fix-broken-rabbitmqctl-commands-when-using-ipv6.patch
Patch0083: 0083-M-N-upgrade-fix-galera-restart.patch
Patch0084: 0084-Add-special-case-handling-for-OVS-upgrade-in-updates.patch
Patch0085: 0085-Add-replacepkgs-to-the-manual-ovs-upgrade-workaround.patch
Patch0086: 0086-Fix-ovs-2.4-to-2.5-upgrade-minor-update-non-controll.patch
Patch0087: 0087-Unset-Keystone-public_endpoint.patch
Patch0088: 0088-Create-nova_api-db-during-the-controller-upgrade.patch
Patch0089: 0089-ha-glance-fs-avoid-a-race-condition.patch
Patch0090: 0090-mitaka-only-Fix-up-OPM-symlinks-before-AODH-migratio.patch
Patch0091: 0091-Configure-nova-neutron-parameter-for-L-to-M-upgrade.patch
Patch0092: 0092-Ensure-working-compute-node-during-the-whole-migrati.patch
Patch0093: 0093-Fix-a-typo-in-the-nova-db-online-data-migrations-dur.patch
Patch0094: 0094-Fixes-ovs-bonding-option.patch
Patch0095: 0095-Stop-the-chronyd-service.patch
Patch0096: 0096-Correct-service-enable-flag.patch
Patch0097: 0097-Allow-operator-to-force-disabling-libvirt-tcp.patch
Patch0098: 0098-Add-support-for-live-migration-over-ssh.patch
Patch0099: 0099-Configure-VNC-Server-listen-address-through-t-h-t.patch
Patch0100: 0100-Remove-extra-include-nova-compute-libvirt.patch
Patch0101: 0101-Aodh-migration-race-condition-when-disabling-the-cei.patch
Patch0102: 0102-Ensure-yum-cache-is-ready-before-update.patch
Patch0103: 0103-downstream-only-New-pcs-config-output-for-keystone-m.patch
Patch0104: 0104-Make-the-openvswitch-2.4-2.5-upgrade-more-robust.patch
Patch0105: 0105-Adds-check-for-existing-yum-process-during-the-legac.patch
Patch0106: 0106-Ignore-systemctl-return-code-in-yum_update.sh.patch
Patch0107: 0107-Fix-ssh-server-options-hiera-value.patch
Patch0108: 0108-Disable-all-repos-during-rhel-registration.patch
Patch0109: 0109-Add-retry-to-RHEL-registration.patch
Patch0110: 0110-Adds-http-proxy-support-for-registering-RHEL-overclo.patch
Patch0111: 0111-Use-disable-in-subscription-manager-to-avoid-shell-e.patch
Patch0112: 0112-Fixes-multiple-issues-with-retry-function-in-rhel-re.patch
Patch0113: 0113-Don-t-disable-satellite-repo-after-registration.patch
Patch0114: 0114-Workaround-for-RHEL-registration-as-localhost.patch
Patch0115: 0115-Maintain-ceph-osd-package-only-on-nodes-hosting-Ceph.patch
Patch0116: 0116-Ensure-nova-migration-package-is-installed-during-mi.patch
Patch0117: 0117-mitaka-Ignore-case-for-bootstrap-node-checks.patch
Patch0118: 0118-Add-missing-variables-for-upgrades.patch
Patch0119: 0119-Add-a-second-proxy-logging-middleware-entry-to-swift.patch

BuildArch:     noarch
BuildRequires: python2-devel
BuildRequires: python-setuptools
BuildRequires: python-d2to1
BuildRequires: python-pbr

Requires:      PyYAML
Requires:      openstack-%{upstream_name}
Obsoletes:     openstack-tripleo-heat-templates-kilo
Obsoletes:     openstack-tripleo-heat-templates-liberty

%description
OpenStack TripleO Heat Templates is a collection of templates and tools for
building Heat Templates to do deployments of OpenStack.  These templates provide support for the clouds running the previous upstream version of OpenStack.

%prep
%setup -q -n tripleo-heat-templates-%{upstream_version}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
%patch0033 -p1
%patch0034 -p1
%patch0035 -p1
%patch0036 -p1
%patch0037 -p1
%patch0038 -p1
%patch0039 -p1
%patch0040 -p1
%patch0041 -p1
%patch0042 -p1
%patch0043 -p1
%patch0044 -p1
%patch0045 -p1
%patch0046 -p1
%patch0047 -p1
%patch0048 -p1
%patch0049 -p1
%patch0050 -p1
%patch0051 -p1
%patch0052 -p1
%patch0053 -p1
%patch0054 -p1
%patch0055 -p1
%patch0056 -p1
%patch0057 -p1
%patch0058 -p1
%patch0059 -p1
%patch0060 -p1
%patch0061 -p1
%patch0062 -p1
%patch0063 -p1
%patch0064 -p1
%patch0065 -p1
%patch0066 -p1
%patch0067 -p1
%patch0068 -p1
%patch0069 -p1
%patch0070 -p1
%patch0071 -p1
%patch0072 -p1
%patch0073 -p1
%patch0074 -p1
%patch0075 -p1
%patch0076 -p1
%patch0077 -p1
%patch0078 -p1
%patch0079 -p1
%patch0080 -p1
%patch0081 -p1
%patch0082 -p1
%patch0083 -p1
%patch0084 -p1
%patch0085 -p1
%patch0086 -p1
%patch0087 -p1
%patch0088 -p1
%patch0089 -p1
%patch0090 -p1
%patch0091 -p1
%patch0092 -p1
%patch0093 -p1
%patch0094 -p1
%patch0095 -p1
%patch0096 -p1
%patch0097 -p1
%patch0098 -p1
%patch0099 -p1
%patch0100 -p1
%patch0101 -p1
%patch0102 -p1
%patch0103 -p1
%patch0104 -p1
%patch0105 -p1
%patch0106 -p1
%patch0107 -p1
%patch0108 -p1
%patch0109 -p1
%patch0110 -p1
%patch0111 -p1
%patch0112 -p1
%patch0113 -p1
%patch0114 -p1
%patch0115 -p1
%patch0116 -p1
%patch0117 -p1
%patch0118 -p1
%patch0119 -p1

%build
%{__python2} setup.py build

%install
%{__python2} setup.py install -O1 --skip-build --root=%{buildroot}
install -d -m 755 %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
cp -ar *.yaml %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
cp -ar puppet %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
cp -ar docker %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
cp -ar firstboot %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
cp -ar extraconfig %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
cp -ar environments %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
cp -ar network %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
cp -ar validation-scripts %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
if [ -d examples ]; then
  rm -rf examples
fi

if [ -d %{buildroot}/%{python2_sitelib}/tripleo_heat_merge ]; then
  rm -rf %{buildroot}/%{python2_sitelib}/tripleo_heat_merge
  rm -f %{buildroot}/%{_bindir}/tripleo-heat-merge
fi

ln -s compat %{buildroot}/%{_datadir}/openstack-%{upstream_name}/%{old_version_name}

%files
%doc README*
%license LICENSE
%{python2_sitelib}/tripleo_heat_templates-*.egg-info
%{_datadir}/openstack-%{upstream_name}/compat
%{_datadir}/openstack-%{upstream_name}/%{old_version_name}

%changelog
* Fri Jan 26 2018 Steve Linabery <slinaber@redhat.com> 2.0.0-62
- Add a second proxy-logging middleware entry to swift-proxy (rhbz#1533948)
- Add missing variables for upgrades (rhbz#1532610)
- [mitaka] Ignore case for bootstrap node checks (rhbz#1532610)
- Ensure nova migration package is installed during minor update (rhbz#1517268)
- Maintain ceph-osd package only on nodes hosting CephOSD service (rhbz#1493744)
- Workaround for RHEL registration as "localhost" (rhbz#1488239)
- Don't disable satellite repo after registration (rhbz#1488239)
- Fixes multiple issues with retry function in rhel-registration. (rhbz#1488239)
- Use --disable= in subscription-manager to avoid shell expansion. (rhbz#1488239)
- Adds http proxy support for registering RHEL overcloud nodes (rhbz#1488239)
- Add retry to RHEL registration (rhbz#1488239)
- Disable all repos during rhel registration (rhbz#1488239)
- Fix ssh server options hiera value (rhbz#1488570)
- Ignore systemctl return code in yum_update.sh (rhbz#1414779 rhbz#1416228 rhbz#1475381)
- Adds check for existing yum process during the legacy minor update
- Make the openvswitch 2.4->2.5 upgrade more robust
- [downstream only] New pcs config output for keystone migration.
- Ensure yum cache is ready before update (rhbz#1451275 rhbz#1446093)
- Aodh migration race condition when disabling the ceilometer alarm.

* Tue Jun 27 2017 Mike Burns <mburns@redhat.com> 2.0.0-58
- Remove extra include nova::compute::libvirt (rhbz#1457132)
- Configure VNC Server listen address through t-h-t (rhbz#1431673)
- Add support for live migration over ssh (rhbz#1428591)
- Allow operator to force disabling libvirt tcp (rhbz#1450032)
- Correct service enable flag (rhbz#1438367)
- Stop the chronyd service (rhbz#1438367)
- Fixes ovs bonding option (rhbz#1417760)
- Fix a typo in the nova db online data migrations during upgrade.
- Ensure working compute node during the whole migration.
- Configure nova neutron parameter for L to M upgrade
- [mitaka-only] Fix up OPM symlinks before AODH migration
- ha/glance-fs: avoid a race condition
- Create nova_api db during the controller upgrade
- Unset Keystone public_endpoint

* Mon Nov 28 2016 Mike Burns <mburns@redhat.com> 2.0.0-41
- Fix ovs 2.4 to 2.5 upgrade - minor update non controllers rhbz#1388543

* Fri Nov 18 2016 Mike Burns <mburns@redhat.com> 2.0.0-34.4
- Add replacepkgs to the manual ovs upgrade workaround and fix a typo
- Add special case handling for OVS upgrade in updates and upgrades
- M/N upgrade fix galera restart. (rhbz#1389166)
- Fix broken rabbitmqctl commands when using ipv6
- Fix api_extensions_path in neutron-opencontrail environment
- Update OpenContrail loadbalancer plugin value
- Populate vnc_api_lib.ini on compute nodes with OpenContrail

* Wed Oct 5 2016 Mike Burns <mburns@redhat.com> 2.0.0-34.2
- move installation under /usr/share/openstack-tripleo-heat-templates rhbz#1382058

* Thu Sep 22 2016 Mike Burns <mburns@redhat.com> 2.0.0-34.1
- Update packaging to match RDO
- templates match OSP 9 templates from 2.0.0-34
